import java.rmi.RemoteException;
import java.rmi.server.RMIClientSocketFactory;
import java.rmi.server.RMIServerSocketFactory;
import java.rmi.server.UnicastRemoteObject;

import javax.security.auth.login.LoginContext;
import javax.security.auth.login.LoginException;


public class ConnexionServeurImpl extends UnicastRemoteObject implements ConnexionServeur {
	private static final long serialVersionUID = 1L;
	private RMIClientSocketFactory clientFactory;
	private RMIServerSocketFactory serverFactory;
	private int port;

	protected ConnexionServeurImpl() throws RemoteException {
		super();
	}

	protected ConnexionServeurImpl(int port, RMIClientSocketFactory clientFactory, RMIServerSocketFactory serverFactory) throws RemoteException {
		// Initialiser l objet UnicastRemoteObject avec ces factories et un num de port sur lequel
		// le remote object sera accessible. Si on met 0 alors un port anonyme sera choisi
		super (port, clientFactory, serverFactory );
		this.clientFactory = clientFactory;
		this.serverFactory = serverFactory;
		this.port= port;
	}
	private ServiceImpl simpl= null ; // modification pour crer un nouveau ServiceImpl()  la premire connexion russie d'un client ;
	@Override
	public Service logon(String username, String passwd) throws RemoteException, LoginException{
		// Verifier si l'utilisateur a bien donn un login et passwd egaux  testUser et testPasswd
		// Si non, renvoyer une instance de LoginException 
		
		LoginContext lc = new LoginContext("MonServeur", new security.module.RemoteCallbackHandler(username, passwd));
		try{
			lc.login();
			System.out.println("Authentifi le sujet "+ lc.getSubject());
		}
		catch (LoginException e){
			System.out.println("Recu "+ username + " et " + passwd + " mais, aprs vrif, ils sont incorrects");
			throw e;
		}
		if (simpl == null) {
			simpl=new ServiceImpl(lc.getSubject(), port, clientFactory, serverFactory);
			// important de passer au constructeur les factory SSL car, c est cet objet remote 'simpl'
			// qui recevra les identificateurs de connexion de l'utilisateur
		}
		return simpl;
	}	
	
}
